Without install-tl

  • ページ: 動作報告
  • 投稿者: 廣島 勉?
  • 状態: 成功?
  • ptexliveバージョン:20090705
  • 投稿日: 2009-07-04 (土) 06:39:37

必要パッケージ

install-tl を実行せず linux distribution の texmf を流用します.

最新の ptexlive がサポートするバージョンではない ともに2007ベースの Fedora 11 と Ubuntu 9.04 で試しました.

人柱的試みです.

ptexlive.cfg

texlive2008-*.iso を /media/iso にマウントして,

  • Fedora 11 の場合,
    ISO_DIR=/media/iso
    TEXLIVE_DIR=$ISO_DIR
    TEXMFDIST=/usr/share/texmf
    EXTRAHYPHEN="dehyph-exptl hyph-utf8"
  • Ubuntu 9.04 の場合
    ISO_DIR=/media/iso
    TEXLIVE_DIR=$ISO_DIR
    TEXMFDIST=/usr/share/texmf-texlive
    EXTRAHYPHEN="dehyph-exptl hyph-utf8 ruhyphen ukrhyph"

その他の設定はサンプルファイルのままです.

EXTRAHYPHEN は latex を動くようにするためコピーが必要になったものです. make test の その他のパートにはコピーしなくても支障がないようでした.

メッセージ

2009-07-07 (火) 記す

土村さんのインストールスクリプトに以下の変更を加えました. Fedora11, Ubuntu 9.04 とも共通です. インストール手順としては install-tl を行わない以外の変更はありません.

なお状態を「成功?」としていますが, 私が必要とするもの platex (p)xdvi (p)dvips (p)dvipdf dvipdfmx pstricks ... はともかく動いている と言う意味です. 限定的使用法のためか 2007 と 2008 をミックスした不具合には未だ出会ってません.

Index: ptexlive/4extract-texmf.sh
===================================================================
--- ptexlive.orig/4extract-texmf.sh
+++ ptexlive/4extract-texmf.sh
@@ -14,9 +14,15 @@ $MV $TEXMF      $TEXMF.install      || e
 tarcp $TEXLIVE_DIR/texmf $TEXMF     || exit
 chmod -R u+rw            $TEXMF     || exit
 tarcp $TEXMF.install     $TEXMF     || exit
+for f in $EXTRAHYPHEN
+do
+    tarcp $TEXLIVE_DIR/texmf-dist/tex/generic/$f $TEXMF/tex/generic/$f || exit
+done
+$MKDIR $TEXMF/tex/latex/ltxmisc
+$CP $TEXLIVE_DIR/texmf-dist/tex/latex/ltxmisc/url.sty $TEXMF/tex/latex/ltxmisc || exit
 
-$LN $TEXLIVE_DIR/tlpkg      $TEXMF/.. || exit
-$LN $TEXLIVE_DIR/texmf-dist $TEXMF/.. || exit
+$LN $TEXMFDIST $TEXMF-dist || exit
+find -L $SRC/inst/bin/$ARCH -mindepth 1 -maxdepth 1 -type l -delete
 
 
 ## for ptex
Index: ptexlive/9realloc.sh
===================================================================
--- ptexlive.orig/9realloc.sh
+++ ptexlive/9realloc.sh
@@ -44,7 +44,7 @@ rm -rf "$PREFIX"
 echo "copying files '$TMP_PREFIX' -> '$PREFIX' ..."
 test -d "$PREFIX" && confirm "'$PREFIX' is found. Overwrite?"
 $MKDIR $PREFIX || exit
-(cd $SRC/inst && tar cf - bin lib include share texmf texmf-dist tlpkg) \
+(cd $SRC/inst && tar cf - bin lib include share texmf texmf-dist) \
     | (cd $PREFIX && tar xf -) || exit
 test "$UID" = 0 && chown -R 0:0 $PREFIX
 cat <<EOF
extract-texmf
realloc

以下は過去の記録

ディスクスペースを節約したいので, 動作報告/41 と同様に intstall-tl をしないで, Ubuntu の apt でインストールされる deb パッケージの texmf を流用してインストールしました.

latex のテストを通すため hyphen 関連のファイルをコピーする必要がありました.

Index: ptexlive/4extract-texmf.sh
===================================================================
--- ptexlive.orig/4extract-texmf.sh	2009-06-18 01:10:15.000000000 +0900
+++ ptexlive/4extract-texmf.sh	2009-07-04 06:10:33.000000000 +0900
@@ -14,9 +14,13 @@
 tarcp $TEXLIVE_DIR/texmf $TEXMF     || exit
 chmod -R u+rw            $TEXMF     || exit
 tarcp $TEXMF.install     $TEXMF     || exit
+tarcp $TEXLIVE_DIR/texmf-dist/tex/generic/dehyph-exptl $TEXMF/tex/generic/dehyph-exptl || exit
+tarcp $TEXLIVE_DIR/texmf-dist/tex/generic/hyph-utf8 $TEXMF/tex/generic/hyph-utf8 || exit
+tarcp $TEXLIVE_DIR/texmf-dist/tex/generic/ruhyphen $TEXMF/tex/generic/ruhyphen || exit
+tarcp $TEXLIVE_DIR/texmf-dist/tex/generic/ukrhyph $TEXMF/tex/generic/ukrhyph || exit
 
-$LN $TEXLIVE_DIR/tlpkg      $TEXMF/.. || exit
-$LN $TEXLIVE_DIR/texmf-dist $TEXMF/.. || exit
+$LN $TEXMFDIST $TEXMF-dist || exit
+find -L $SRC/inst/bin/$ARCH -mindepth 1 -maxdepth 1 -type l -delete
 
 
 ## for ptex
Index: ptexlive/5macro.sh
===================================================================
--- ptexlive.orig/5macro.sh
+++ ptexlive/5macro.sh
@@ -243,5 +243,5 @@ if test -f $SRC/inst/texmf-config/web2c/
     $MV $SRC/inst/texmf-config/web2c/updmap.cfg $SRC/inst/texmf/web2c/ || exit
 fi
 $MKTEXLSR 2> /dev/null || exit
-$UPDMAP   2> /dev/null || exit
+$UPDMAP --syncwithtrees  2> /dev/null || exit
  echo ""
Index: ptexlive/9realloc.sh
===================================================================
--- ptexlive.orig/9realloc.sh
+++ ptexlive/9realloc.sh
@@ -44,7 +44,7 @@ rm -rf "$PREFIX"
 echo "copying files '$TMP_PREFIX' -> '$PREFIX' ..."
 test -d "$PREFIX" && confirm "'$PREFIX' is found. Overwrite?"
 $MKDIR $PREFIX || exit
-(cd $SRC/inst && tar cf - bin lib include share texmf texmf-dist tlpkg) \
+(cd $SRC/inst && tar cf - bin lib include share texmf texmf-dist) \
     | (cd $PREFIX && tar xf -) || exit
 test "$UID" = 0 && chown -R 0:0 $PREFIX
 cat <<EOF
@@ -70,7 +70,7 @@ LD_LIBRARY_PATH=$PREFIX/lib/$ARCH:$LD_LI
 export PATH LD_LIBRARY_PATH TEXMFMAIN
 
 $MKTEXLSR 2> /dev/null || exit
-$UPDMAP   2> /dev/null || exit
+$UPDMAP --syncwithtrees  2> /dev/null || exit
 (fmtutil-sys --all 2>&1) > /dev/null
 # You can check if "$TMP_PREFIX" is not included in files under $PREFIX.
 # grep $TMP_PREFIX -l -r $PREFIX || true

  • ディスクスペースの節約が本当にできてしまうとは驚きました。--syncwithtrees は、ptexlive に取り込んでもいいかもしれませんね。 -- 土村 2009-07-04 (土) 10:33:21
  • install-tl でインストールスキーマが選べるようになるので,ぜひお願いします.texlive で scheme-basic を選択して ptexlive を --syncwithtrees でインストールした場合.サイズはそれぞれ 126M + 135M (on Fedora 11)になりました. -- 廣島 2009-07-04 (土) 12:17:36
  • 20090705での採用ありがとうございます.確認はまだですが --syncwithtrees は 9realloc.sh にも必要です. -- 廣島 2009-07-06 (月) 03:45:32
  • 早とちりでした.4extract-texmf.sh で処理した updmap.cfg を使うので 9realloc.sh では不要ということですね. -- 廣島 2009-07-06 (月) 04:05:28
  • はい、そのように狙ってみましたが、実は動作確認ができてないので、ちょっと不安があります。 -- 土村 2009-07-06 (月) 17:01:37
  • scheme-basic でインストール通りました.ただその前に without install-tl な作業に取り組んでいまして Fedora,Ubuntu とも通した所です.私としては without の方を(ptetex3 をバックアップとして)本格運用かなと考えております.20090705 の without のパッチが御入用ならこの動作報告/43に追加 & 編集しましょうか? -- 廣島 2009-07-06 (月) 17:59:31
  • 動作確認ありがとうございます。これで安心です。
    without install-tl のパッチというのは、あれば喜ばれる人もいると思います。ptexlive に取り込めるかどうかという視点では、ベースとなる TeX Live パッケージの作られ方が同じであれば、可能かもしれません。ディストリビューションによってどの程度ばらつきがあるでしょうか。ともかく、そういうことが可能である、という情報は有益だと思いますので、いつでも構いませんので、お願いできればありがたいです。 -- 土村 2009-07-06 (月) 20:03:39
  • 本質にあったタイトルにしたかったので,OS・バージョン名を変更してしまいましたが宜しかったでしょうか? ところで url.sty の扱いには少し困りました.eightbit2hex は3箇所のディレクトリを順に調べ最初に見つかった url.sty を処理し,ptex のツリーに挿入しますね. install-tl で HD インストールされた url.sty(Ver3.3)が2箇所目のディレクトリで見つかることになりますが,without では distribution の url.sty(Ver3.2) がここで引っかかってしまい md5check が失敗します.そこで ISO から,優先順位の高い1箇所目のディレクトリに url.sty をコピーして凌ぎました.その際思ったことは「md5sum をチェックする以上はユーザに改変されていないことを期待するのだから,改変されていないはずの ISO の url.sty をソースに決め打ちし,他のディレクトリは検索対象から外すのが本筋ではないか?」です.HD インストール済みの url.sty はユーザの都合で改変されている可能性が(非常に薄いですが)有りますから.(済みません.邪道が正道を説くようで恐れ多いです) -- 廣島 2009-07-07 (火) 17:01:24
  • 詳しく書いていただいてありがとうございます。タイトル、これでよいと思います。
    md5check はお手間をとらせてしまいました。昔は書き換えに失敗するトラブルが多くて(コマンドのバージョン違いでオプションの解釈が微妙に違ったりして)、それで厳密にチェックすることにしたのですが、最近ではあまりトラブルにならないので、少しチェックを緩くしても実害はなさそうな気がしています。 ユーザ側で、url.sty だけチェックされたくなければ md5sum/texmf から該当行を削除してもらう、という手もあります。 md5sum/texmf を見てみると、url.sty 以外は cat で作るファイルばかりですねぇ。検査しなくてもよさそうな気もしてきました。 -- 土村 2009-07-08 (水) 10:20:32
  • 最初はおっしゃる通りリストから url.sty を外して通しました.(手っ取り早いですからね)その後 No check というのもどうかと思い直して現在の形になりました.「実害のない(であろう)ファイルについては md5 不一致の警告メッセージを出す(log に残す)が,インストールスクリプトは停止させない」というのは落としどころとして如何でしょうか? -- 廣島 2009-07-08 (水) 13:48:19
  • Fedora11 の TeX Live は 2007 みたいですが、正しいでしょうか。動いているという報告をいただいてましたから、2008 だとばかり思い込んでいましたが、気になって調べてみると 2007 という情報が出てきて驚いています。 せっかくご報告いただいていますが、2007 の texmf に 2008 の実行形式を混ぜるということになると、(日本語以前の問題として)ちゃんと動いているとは、にわかには信じられないのですが...もちろん、個人的に使っていただくのには問題ありませんが、ptexlive としてそういう用途を考慮するのは、ちょっとどうかという気がしてきました。 -- 土村 2009-07-11 (土) 01:11:49
  • ご懸念の通り残念ながら Fedora11, Ubuntu9.04 とも 2007 です.動作報告 41 の必要パッケージに並べた通りです.バージョンの不一致はこの時点で既に認識しており伏せたつもりはなかったのですが,最初に Fedora Ubuntu の2つに分けて投稿してしまったのが誤解を招く原因で良くなかったですね.「邪道な方法」と当初から重々思っています.20090705 でのことを追加して構いませんかとお尋ねしたのも,先の url.sty についてのコメントの「邪道が正道を...」の文もそのつもりで書いたものだったのですが... 後者については「邪道な方法」に便宜を図ってくれというものではなく,その過程で出会った url.sty のソースの選択方針に対する単純な疑問でした.状態の「成功」がまずければ修正致しますし,報告そのものを削除しても(またはして頂いても)構いませんが,如何しましょうか? ともかくも必要パッケージの部分に注意書きを追加しておきます. -- 廣島 2009-07-11 (土) 02:01:18
  • そういうことだったのですか。報告いただくことは構いません。ひょっとしたら、本当にちゃんと動く組合せ(texmf とバイナリ)があるのかもしれませんし。
    url.sty、というより、eightbit2hex() が3箇所も見ている理由ですが、ptetex3 時代の 6babel.sh なんかでは本当にこういう場所のファイルを参照してました。現状では Babel 対応できてませんので、役には立っていませんが。
    将来、どんなファイルを書き換えることになるかわかりませんので、md5sum の不一致はエラーで止めるということにしておきたいのですが、よろしいでしょうか。想定している texmf ツリー以外では、自己責任で md5sum のチェックを外していただくということで。 -- 土村 2009-07-12 (日) 00:01:57
  • ご配慮ありがとうございます.version mix したことによる不具合に出会った場合は報告させていただきます.ところで,私の疑問の要点は「なぜ,変換元のソースがマウントした ISO に属するファイルでは無いのだろうか」でした.もしも「インストールスキーマの選択」が正式採用だとするなら,変換元のファイルが HD にインストールされていないということが起こり得るのではないでしょうか? (インストールに成功しましたので,url.sty は scheme-basic に含まれているわけですね.) -- 廣島 2009-07-12 (日) 11:52:13
  • うーん、そうですか、「インストールスキーマの選択」の正式採用には、大きな困難があるということですね。隠し機能ということでお願いします。
    TEXMFDIST や SRC_TAR は、元は OS 付属 TeX パッケージ製作のために準備したものです。パッケージを作る上では、ISO を読みに行ってもらっては困るので、これを使って別の場所を読ませるようにします。TEXMFDIST は、install-tl と組み合わせるのに内部的に流用しましたが、だからと言って ISO を見にいくような変更をすると、パッケージ製作者から「ここにもパッチを書かねば」と吐息が聞こえてきそうです。
    ptexlive の個人ユーザがディスクスペースを節約することと、OS 付属 TeX パッケージ製作者が ptexlive を採用することと、どちらを重視するかといえば、後者ですので、よろしくご理解をお願いいたします。次のFedora/Ubuntu の TeX Live には ptexlive 拡張が入る、というのが幸せですよね?本当に入る保証はどこにもありませんが。-- 土村 2009-07-12 (日) 22:03:01
  • お答えありがとうございます.「パッケジャーへの配慮を重視」の方針とのこと,了解いたしました.公式パッケージを念頭において話すならば,Fedora/Debian ともその厳しいポリシーに従って書かれたビルドスクリプトが既にあり(or 開発中),ここでの「ISO か texmf ツリーか」の議論が届かない世界のように思われるので,Fedora/Ubuntu ユーザとしてはパッケージャよりユーザ志向であって欲しいと思っていました.ちなみに Debian では 2009 のパッケージングの開発に取りかかっているみたいです.2008 は跳ばされるのでしょうか? Fedora の開発者の間では texlive のライセンスのグレーさが話題になってました.ライセンスチェックのマンパワーが不足していて「TeX は Fedora から外そう」という冗談とも悲鳴ともつかない発言が飛び交っていました.Debian の動向によっては Fedora も 2008 は跳ばすかも. -- 廣島 2009-07-14 (火) 01:24:33
  • 海外Linuxディストロに大変お詳しいのですね。ご助言ありがとうございます。TeX Live 2009 は早めに対応したいと思います。Fedora の噂は耳にしていましたが、Debian の話は知りませんでした。もう 2009 とは、ずいぶん気が早いですね。
    ptetex3/ptexlive は国内 Linux や MacOSX パッケージなどでかなり使っていただいてます(cf.コンパイル済みパッケージ[extlink])が、最終目標は ptetexWiki:開発目標開発状況 に書いてますように、upstream(TeX Live?)に取り込んでもらうことです。 もちろん海外 Linux に入ることも含みます。 これには当然 CTAN に登録しなければならないと思ってますが、それ以前に国内の意思統一も必要だろうと思っています。 ところが コマンド名問題 も完全解決とはいえず、苦労しています。ご指導お願いできれば心強いです。 -- 土村 2009-07-15 (水) 01:38:31
  • 開発目標を改めて読まさせて頂きました.国内の小回りの効くディストリビューションと異なり,Fedora や Ubuntu では「上流に取り込まれない限り ptexlive 採用は無い」との感想を持っています(実は 今年 5月の dvipdfmx のパッチを Ubuntu Forum に流した e から始まる長い HN の持ち主は私です.そのときの Japanese Team の皆さんのやり取りを傍で読んでいてますますそう思いました)ので,全面的に賛成です. -- 廣島 2009-07-17 (金) 13:56:25
  • TeX Live と Fedora/Ubuntu のどちらが先に取り込んでもらえるか、あまり区別して考えてなかったのですが、TeX Live のほうが有望だということですね。最終目標はもちろん両方ではありますが、心して活動したいと思います。 -- 土村 2009-07-19 (日) 20:11:08
  • Ubuntu 9.04 と ptexlive-20091009 と texlive2008-20080822.iso の組み合わせでコンパイルし、utf-8 のファイルに対して動作するかだけチェックしました。うまくいっているようです。EXTRAHYPHEN ですが、上の説明では EXTRAPHYPHEN と typo があるようでした。 -- tako 2010-10-24 (日) 23:19:08


トップ   編集 凍結 差分 バックアップ 添付 複製 名前変更 リロード   新規 一覧 単語検索 最終更新   ヘルプ   最終更新のRSS
Last-modified: 2010-10-24 (日) 23:19:35 (2609d)